//
//  EMBAnnotationEmberText.h
//  EmberCommon
//
//  Created by Damien DeVille on 03/04/2013.
//  Copyright (c) 2013 Realmac Software. All rights reserved.
//

#import "EMBEmberAnnotations/EMBAnnotationEmber.h"

@interface EMBAnnotationEmberText : EMBAnnotationEmber

/*!
	\brief
	Create a text annotation.
	
	\param orientation
	The orientation of the annotation.
	
	\param position
	The position of the annotation in the root layer coordinate system.
	
	\param text
	The text to display in the annotation.
	
	\param boxSize
	The size of the text box.
 */
- (id)initWithOrientation:(EMBEmberAnnotationOrientation)orientation position:(CGPoint)position text:(NSString *)text boxSize:(CGSize)boxSize;

/*!
	\brief
	The text displayed in the annotation.
 */
@property (copy, nonatomic) NSString *text;
extern NSString * const EMBAnnotationEmberTextTextKey;

/*!
	\brief
	The size of the box containing the text.
 */
@property (assign, nonatomic) CGSize boxSize;
extern NSString * const EMBAnnotationEmberTextBoxSizeKey;

- (NSString *)fontName;
+ (NSString *)fontName;

@end
