//
// Copyright (C) 2008-2012 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//

#import "EMBEmberAnnotations/EMBAnnotationLittleSnapper.h"

struct _EMBLine {
	CGPoint start;
	CGPoint end;
};
typedef struct _EMBLine EMBLine;

static inline EMBLine EMBLineMake(CGPoint start, CGPoint end) {
	EMBLine line = {};
	line.start = start;
	line.end = end;
	return line;
}

static inline BOOL EMBLineEqualToLine(EMBLine line1, EMBLine line2) {
	return (CGPointEqualToPoint(line1.start, line2.start) && CGPointEqualToPoint(line1.end, line2.end));
}

static const EMBLine EMBLineZero = {{0.0, 0.0}, {0.0, 0.0}};

@interface EMBAnnotationLittleSnapperLinear : EMBAnnotationLittleSnapper

@property (readonly, assign, nonatomic) EMBLine line;

@end

@interface EMBAnnotationLittleSnapperLine : EMBAnnotationLittleSnapperLinear

@end

@interface EMBAnnotationLittleSnapperArrow : EMBAnnotationLittleSnapperLinear

@end
