//
//  EMBEmberAnnotations-Constants.h
//  EmberCommon
//
//  Created by Damien DeVille on 19/09/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <TargetConditionals.h>

#if TARGET_OS_IPHONE
#import <UIKit/UIKit.h>
#else
#import <AppKit/AppKit.h>
#endif /* TARGET_OS_IPHONE */

extern NSString * const EMBEmberAnnotationsBundleIdentifier;

typedef NS_ENUM(NSInteger, EMBEmberAnnotationsErrorCode) {
	EMBEmberAnnotationsErrorCodeUnknown = 0,
	
	EMBEmberAnnotationsCannotRecognizeShapeError = -100,
};

extern NSString * const EMBEmberAnnotationsErrorDomain;

typedef NS_ENUM(NSInteger, EMBEmberAnnotationTool) {
	EMBEmberAnnotationToolSelect = 1,
	EMBEmberAnnotationToolPan = 2,
	EMBEmberAnnotationToolZoomIn = 3,
	EMBEmberAnnotationToolZoomOut = 4,
	EMBEmberAnnotationToolCrop = 5,
	EMBEmberAnnotationToolRotateClockwise = 6,
	EMBEmberAnnotationToolRotateAntiClockwise = 7,
	EMBEmberAnnotationToolPen = 8,
	EMBEmberAnnotationToolText = 9,
	EMBEmberAnnotationToolDrawingPicker = 10,
	EMBEmberAnnotationToolSmartPen = 11,
	EMBEmberAnnotationToolPixelate = 12,
	EMBEmberAnnotationToolBlur = 13,
	EMBEmberAnnotationToolPicker = 14,
};

typedef NS_ENUM(NSInteger, EMBEmberAnnotationColor) {
	EMBEmberAnnotationColorBlack = 1,
	EMBEmberAnnotationColorWhite = 2,
	EMBEmberAnnotationColorRed = 3,
	EMBEmberAnnotationColorBlue = 4,
	EMBEmberAnnotationColorOrange = 5,
	EMBEmberAnnotationColorGreen = 6,
};

typedef NS_ENUM(NSInteger, EMBEmberAnnotationLineWidth) {
	EMBEmberAnnotationLineWidthSmall = 1,
	EMBEmberAnnotationLineWidthMedium = 2,
	EMBEmberAnnotationLineWidthLarge = 3,
};

typedef NS_ENUM(NSInteger, EMBEmberAnnotationOrientation) {
	EMBEmberAnnotationOrientationTop = 0,		// 0th row is at the top, and 0th column is on the left.
	EMBEmberAnnotationOrientationRight = 1,		// 0th row is on the right, and 0th column is the top.
	EMBEmberAnnotationOrientationBottom = 2,	// 0th row is at the bottom, and 0th column is on the right.
	EMBEmberAnnotationOrientationLeft = 3,		// 0th row is on the left, and 0th column is the bottom.
};

extern const CGFloat EMBEmberAnnotationPadding;
