//
//  EMBAutoImportProcessingController.h
//  EmberMac
//
//  Created by Damien DeVille on 1/21/14.
//  Copyright (c) 2014 Realmac Software. All rights reserved.
//

#import <CoreData/CoreData.h>

#import "EMBEmberAppKit/EMBAutoImportController.h"

@class EMBEmberLibrary;

@interface EMBAutoImportProcessingController : NSObject <EMBAutoImportController>

/*!
	\brief
	The managed object context managing the import. It should be a context associated with the ember library persistent store.
 */
@property (strong, nonatomic) NSManagedObjectContext *importManagedObjectContext;

/*!
	\brief
	The Ember library to which snaps will be imported into.
 */
@property (strong, nonatomic) EMBEmberLibrary *emberLibrary;

/*!
	\brief
	The operation queue where the auto import operations are enqueued on.
 */
@property (readonly, strong, nonatomic) NSOperationQueue *importOperationQueue;

@end
