//
//  EMBEmberAppKit-Functions.h
//  EmberMac
//
//  Created by Damien DeVille on 11/01/2013.
//  Copyright (c) 2013 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

extern NSURL *EMBEmberDefaultBrowserLocation(NSError **errorRef);

/*!
	\brief
	The bundle identifier of the default browser application with the case not 
	guarenteed to match that of its Info.plist entry.

	If a handler entry in the Launch Services register exists then the returned value is 
	likely to be all lowercase (entrys in the database are currently all lowercase).
	If no entry is found then the system returns the default application's bundle 
	identifer and is likely to preserving the case.
 */
extern NSString *EMBEmberDefaultBrowserCaseInsensitiveBundleIdentifier(void);
