//
//  EMBEmberData.h
//  EMBEmberData
//
//  Created by Damien DeVille on 19/09/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "EMBEmberData/EMBEmberData-Constants.h"

/*
	Ember library
 */
#import "EMBEmberData/EMBEmberLibrary.h"
#import "EMBEmberData/EMBEmberLibraryConfiguration.h"
#import "EMBEmberData/EMBEmberLibraryConfiguration+Defaults.h"
#import "EMBEmberData/EMBEmberLibraryCoordinator.h"
#import "EMBEmberData/EMBEmberJournal.h"
#import "EMBEmberData/EMBEmberLibraryBackup.h"
#import "EMBEmberData/EMBCoordinatedDeletionOperation.h"
#import "EMBEmberData/EMBCoordinatedMigrationOperation.h"
#import "EMBEmberData/EMBEmberFileManager.h"
#import "EMBEmberData/EMBDirectoryWatcher.h"

/*
	Managed objects
 */
#import "EMBEmberData/EMBEmberData+ManagedObjects.h"
/*
	Snap document
 */
#import "EMBEmberData/EMBSnapDocument.h"
#import "EMBEmberData/EMBSnapDocument+Content.h"
#import "EMBEmberData/EMBSnapDocumentCoordinator.h"

/*
	Value transformer
 */
#import "EMBEmberData/EMBDateStringValueTransformer.h"
#import "EMBEmberData/EMBImageDimensionsValueTransformer.h"
#import "EMBEmberData/EMBPortableImageValueTransformer.h"

/*
	Migration policies
 */
#if !TARGET_OS_IPHONE
#import "EMBEmberData/EMBSnapMigrationPolicy.h"
#endif
#import "EMBEmberData/EMBCloudMigrationHelper.h"

/*
	Dropbox glue
	
	Only needed on iOS to avoid linking against the Dropbox static library from both the framework and
	the main application linking against the framework. This would lead to duplicate symbols and troubles.
 */
#if TARGET_OS_IPHONE
#import "EMBEmberData/EMBEmberDropboxGlue.h"
#endif /* TARGET_OS_IPHONE */

/*
	Model default items
 */
#import "EMBEmberData/EMBSidebarItem+EMBDefaultItems.h"
#import "EMBEmberData/EMBSubscription+EMBDefaultItems.h"

/*
	Colour analysis
 */
#import "EMBEmberData/EMBEmberNaturalLanguageColors.h"

/*
	Helpers
 */
#import "EMBEmberData/EMBPersistentStoreCopying.h"
#import "EMBEmberData/NSManagedObject+EMBPersistentStoreCopying.h"
#import "EMBEmberData/NSManagedObject+EMBAdditions.h"
#import "EMBEmberData/NSManagedObjectModel+EMBEmberDataModel.h"
#import "EMBEmberData/NSURL+EMBDropboxSupport.h"
#import "EMBEmberData/NSPersistentStoreCoordinator+Legacy.h"
