//
//  EMBSidebarItem+EMBDefaultItems.h
//  EmberCommon
//
//  Created by Damien DeVille on 27/09/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import "EMBEmberData/EMBEmberData.h"

typedef NS_ENUM(NSUInteger, EMBSidebarItemHidingOptions) {
	EMBSidebarItemHideUnprocessed = 1 << 0,
	EMBSidebarItemHideLastImport = 1 << 1,
	EMBSidebarItemHideColours = 1 << 2,
	
	EMBSidebarItemHideTypeScreen = 1 << 10,
	EMBSidebarItemHideTypeWeb = 1 << 11,
	EMBSidebarItemHideTypePhoto = 1 << 12,
	EMBSidebarItemHideTypeTablet = 1 << 13,
	EMBSidebarItemHideTypePhone = 1 << 14,
	EMBSidebarItemHideTypeText = 1 << 15,
	EMBSidebarItemHideTypeVideo = 1 << 16,
	EMBSidebarItemHideTypeBookmark = 1 << 17,
};

extern NSString * const EMBSidebarItemHidingOptionsDefaultKey;

extern NSString * const EMBSidebarItemLibraryIdentifier;
	extern NSString * const EMBSidebarItemEverythingIdentifier;
	extern NSString * const EMBSidebarItemUnprocessedIdentifier;
	extern NSString * const EMBSidebarItemLastImportIdentifier;
	extern NSString * const EMBSidebarItemColoursIdentifier;
extern NSString * const EMBSidebarItemTypesIdentifier;
	extern NSString * const EMBSidebarItemScreenIdentifier;
	extern NSString * const EMBSidebarItemWebIdentifier;
	extern NSString * const EMBSidebarItemPhotoIdentifier;
	extern NSString * const EMBSidebarItemTabletIdentifier;
	extern NSString * const EMBSidebarItemPhoneIdentifier;
	extern NSString * const EMBSidebarItemTextIdentifier;
	extern NSString * const EMBSidebarItemVideoIdentifier;
	extern NSString * const EMBSidebarItemBookmarkIdentifier;
extern NSString * const EMBSidebarItemCollectionsIdentifier;

typedef NS_ENUM(NSUInteger, EMBSidebarItemRootType) {
	EMBSidebarItemRootTypeLibrary = 0,
	EMBSidebarItemRootTypeTypes = 1,
	EMBSidebarItemRootTypeCollections = 2,
};

@interface EMBSidebarItem (EMBDefaultItems)

+ (BOOL)createDefaultSidebarItemsInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext persistentStore:(NSPersistentStore *)persistentStore error:(NSError **)errorRef;

+ (NSArray *)sidebarRootSections:(NSManagedObjectContext *)managedObjectContext error:(NSError **)errorRef;
+ (EMBSidebarFolder *)rootSectionItemForType:(EMBSidebarItemRootType)type managedObjectContext:(NSManagedObjectContext *)managedObjectContext error:(NSError **)errorRef;

+ (NSArray *)sidebarItemsForSectionType:(EMBSidebarItemRootType)type managedObjectContext:(NSManagedObjectContext *)managedObjectContext error:(NSError **)errorRef;
+ (NSArray *)filteredSidebarItemsForSectionType:(EMBSidebarItemRootType)type managedObjectContext:(NSManagedObjectContext *)managedObjectContext userDefaults:(NSUserDefaults *)userDefaults error:(NSError **)errorRef;

+ (BOOL)updateSidebarItemHiddenState:(NSManagedObjectContext *)managedObjectContext userDefaults:(NSUserDefaults *)userDefaults error:(NSError **)errorRef;

@property (readonly, assign, nonatomic) EMBSidebarItemRootType rootType;

@end

extern EMBSnapType EMBSnapTypeFromPredicateSidebarItemIdentifier(NSString *identifier);
extern EMBSidebarItemHidingOptions EMBSidebarItemHidingOptionForItemIdentifier(NSString *identifier);
extern NSPredicate *EMBSidebarItemCollectionSectionTopChildrenPredicate(void);
