//
// Copyright (C) 2010-2012 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//

#import <CoreData/CoreData.h>

#import "EMBPersistentStoreCopying.h"

extern NSString * const EMBSidebarItemEntityName;

@class EMBSidebarFolder;

@interface EMBSidebarItem : NSManagedObject <EMBPersistentStoreCopying>

+ (id)findSidebarItemWithIdentifier:(NSString *)identifier managedObjectContext:(NSManagedObjectContext *)managedObjectContext persistentStore:(NSPersistentStore *)persistentStore;

+ (id)createSidebarItemWithEntityName:(NSString *)entityName managedObjectContext:(NSManagedObjectContext *)managedObjectContext persistentStore:(NSPersistentStore *)persistentStore title:(NSString *)title parent:(EMBSidebarFolder *)parent;
+ (id)createSidebarItemInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext persistentStore:(NSPersistentStore *)persistentStore title:(NSString *)title parent:(EMBSidebarFolder *)parent;

extern NSString * const EMBSidebarItemIdentifierKey;
@property (copy, nonatomic) NSString *identifier;

extern NSString * const EMBSidebarItemIconNameKey;
@property (copy, nonatomic) NSString *iconName;

extern NSString * const EMBSidebarItemTitleKey;
@property (copy, nonatomic) NSString *title;

extern NSString * const EMBSidebarItemOrderKey;
@property (strong, nonatomic) NSNumber *order;

extern NSString * const EMBSidebarItemDefaultSortAscendingKey;
@property (assign, nonatomic) BOOL defaultSortAscending;

extern NSString * const EMBSidebarItemDefaultSortKeyKey;
@property (copy, nonatomic) NSString *defaultSortKey;

extern NSString * const EMBSidebarItemDeletableKey;
@property (assign, getter = isDeletable, nonatomic) BOOL deletable;

extern NSString * const EMBSidebarItemDraggableKey;
@property (assign, getter = isDraggable, nonatomic) BOOL draggable;

extern NSString * const EMBSidebarItemTitleEditableKey;
@property (assign, getter = isTitleEditable, nonatomic) BOOL titleEditable;

extern NSString * const EMBSidebarItemHiddenKey;
@property (assign, getter = isHidden, nonatomic) BOOL hidden;

extern NSString * const EMBSidebarItemParentFolderKey;
@property (strong, nonatomic) EMBSidebarFolder *parentFolder;

extern NSString * const EMBSidebarItemGroupItemKey;
@property (readonly, assign, getter = isGroupItem, nonatomic) BOOL groupItem;

extern NSString * const EMBSidebarItemLeafKey;
@property (readonly, assign, getter = isLeaf, nonatomic) BOOL leaf;

extern NSString * const EMBSidebarItemChildCountKey;
@property (readonly, assign, nonatomic) NSUInteger childCount;

extern NSString * const EMBSidebarItemBadgeNumberKey;
@property (readonly, assign, nonatomic) NSUInteger badgeNumber;

+ (NSFetchRequest *)fetchRequestInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext persistentStores:(NSArray *)persistentStores;

#if TARGET_OS_IPHONE
+ (NSFetchedResultsController *)fetchedResultsControllerInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext persistentStores:(NSArray *)persistentStores;
#endif /* TARGET_OS_IPHONE */

+ (NSString *)entityName;

@end
