//
// Copyright (C) 2010-2012 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//

#import <CoreData/CoreData.h>

#if TARGET_OS_IPHONE
	#import <ImageIO/ImageIO.h>
#endif /* TARGET_OS_IPHONE */

extern NSString * const EMBSubscriptionItemEntityName;

@class EMBSubscription;

@interface EMBSubscriptionItem : NSManagedObject

+ (EMBSubscriptionItem *)createSubscriptionItemInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

extern NSString * const EMBSubscriptionItemAuthorKey;
@property (strong, nonatomic) NSString *author;

extern NSString * const EMBSubscriptionItemTitleKey;
@property (strong, nonatomic) NSString *title;

extern NSString * const EMBSubscriptionItemCommentsKey;
@property (strong, nonatomic) NSString *comments;

extern NSString * const EMBSubscriptionItemDateKey;
@property (strong, nonatomic) NSDate *date;

extern NSString * const EMBSubscriptionItemImageURLKey;
@property (strong, nonatomic) NSURL *imageURL;

extern NSString * const EMBSubscriptionItemImageURLStringKey;
@property (strong, nonatomic) NSString *imageURLString;

extern NSString * const EMBSubscriptionItemLinkURLKey;
@property (strong, nonatomic) NSURL *linkURL;

extern NSString * const EMBSubscriptionItemLinkURLStringKey;
@property (strong, nonatomic) NSString *linkURLString;

extern NSString * const EMBSubscriptionItemReadKey;
@property (assign, getter = isRead, nonatomic) BOOL read;

extern NSString * const EMBSubscriptionItemImportedKey;
@property (assign, getter = isImported, nonatomic) BOOL imported;

extern NSString * const EMBSubscriptionItemAbsoluteImageURLKey;
@property (readonly, copy, nonatomic) NSURL *absoluteImageURL;

extern NSString * const EMBSubscriptionItemImagePathKey;
@property (copy, nonatomic) NSString *imagePath;

extern NSString * const EMBSubscriptionItemAbsoluteThumbnailURLKey;
@property (readonly, copy, nonatomic) NSURL *absoluteThumbnailURL;

extern NSString * const EMBSubscriptionItemThumbnailPathKey;
@property (copy, nonatomic) NSString *thumbnailPath;

extern NSString * const EMBSubscriptionItemSubscriptionURIRepresentationKey;
@property (strong, nonatomic) NSString *subscriptionURIRepresentation;

/*!
	\brief
	Return the subscription matching the subscriptionURI in the managed object context.
 */
- (EMBSubscription *)subscriptionInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

+ (NSPredicate *)unreadItemsPredicate;

+ (NSFetchRequest *)fetchRequestWithSubscription:(EMBSubscription *)subscription managedObjectContext:(NSManagedObjectContext *)managedObjectContext;
+ (NSPredicate *)predicateWithSubscription:(EMBSubscription *)subscription managedObjectContext:(NSManagedObjectContext *)managedObjectContext;

#if TARGET_OS_IPHONE
+ (NSFetchedResultsController *)fetchedResultsControllerWithSubscription:(EMBSubscription *)subscription managedObjectContext:(NSManagedObjectContext *)managedObjectContext;
#endif /* TARGET_OS_IPHONE */

@end
