//
// Copyright (C) 2009-2012 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//

#import <CoreData/CoreData.h>

#import "EMBPersistentStoreCopying.h"

extern NSString * const EMBTagEntityName;

@interface EMBTag : NSManagedObject <EMBPersistentStoreCopying>

+ (EMBTag *)createTagWithTitle:(NSString *)tagTitle managedObjectContext:(NSManagedObjectContext *)managedObjectContext persistentStore:(NSPersistentStore *)persistentStore;

+ (NSUInteger)numberOfTagsLikeString:(NSString *)tagString managedObjectContext:(NSManagedObjectContext *)managedObjectContext error:(NSError **)errorRef;
+ (NSArray *)findTagsStartingWith:(NSString *)startsWith managedObjectContext:(NSManagedObjectContext *)managedObjectContext error:(NSError **)errorRef;
+ (EMBTag *)findTagWithTitle:(NSString *)tagTitle managedObjectContext:(NSManagedObjectContext *)managedObjectContext error:(NSError **)errorRef;

extern NSString * const EMBTagTitleKey;
@property (copy, nonatomic) NSString *title;

extern NSString * const EMBTagSnapsKey;
@property (strong, nonatomic) NSSet *snaps;

@end

@class EMBSnap;

@interface EMBTag (CoreDataGeneratedAccessors)

- (void)addSnapsObject:(EMBSnap *)snap;
- (void)removeSnapsObject:(EMBSnap *)snap;
- (void)addSnaps:(NSSet *)snaps;
- (void)removeSnaps:(NSSet *)snaps;

@end
