//
//  EMBEmberHelpers-Functions.h
//  EmberCommon
//
//  Created by Damien DeVille on 21/11/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

/*!
	\brief
	Find the string encoding for a given MIME type.
 */
extern NSStringEncoding EMBEmberStringEncodingForMIMEType(NSString *MIMEType, NSError **errorRef);

/*!
	\brief
	Visit the predicate tree yielding each predicate that is found on the way.
 */
extern void EMBEmberVisitPredicateTree(NSPredicate *predicate, void (^predicateYielder)(NSPredicate *subpredicate));

/*!
	\brief
	Update a predicate tree by visiting and updating each predicate found on the way.
	An exception is thrown if a predicate that is **not** an NSCompoundPredicate or NSComparisonPredicate is found in the tree.
 */
extern NSPredicate *EMBEmberUpdatePredicateTree(NSPredicate *predicate, NSPredicate * (^updatePredicate)(NSComparisonPredicate *comparisonPredicate));

/*!
	\brief
	Retrieve a temporary location for writing data to. The `destinationURL` is optional, but when provided 
	is used to help retreive a temporary location that is based on the same volume.
 */
extern NSURL *EMBEmberTemporaryExportDirectoryForDestinationURL(NSURL *destinationURL, NSError **errorRef);
