//
//  Ember-Macros.h
//  Ember
//
//  Created by Damien DeVille on 05/05/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#if !defined(__has_feature)
	#define __has_feature(x) 0
#endif /* !defined(__has_feature) */

#if __has_feature(attribute_ns_consumed)
	#define RM_EMBER_NS_CONSUMED __attribute__((ns_consumed))
#else
	#define RM_EMBER_NS_CONSUMED
#endif /* __has_feature(attribute_ns_consumed) */

#if __has_feature(attribute_cf_consumed)
	#define RM_EMBER_CF_CONSUMED __attribute__((cf_consumed))
#else
	#define RM_EMBER_CF_CONSUMED
#endif /* __has_feature(attribute_cf_consumed) */

#if !defined(__clang_analyzer__)
	#define COMPILE_TYPE COMPILE_TYPE_BUILD
#else
	#define COMPILE_TYPE COMPILE_TYPE_ANALYZE
#endif /* !defined(__clang_analyzer__) */

#if !defined(__clang_major__)
	#define __clang_major__ 0
#endif /* !defined(__clang_major__) */

#if !defined(__clang_minor__)
	#define __clang_minor__ 0
#endif /* !defined(__clang_minor__) */

#define COMPILE_TYPE_BUILD 1
#define COMPILE_TYPE_ANALYZE 2

#ifndef MAC_OS_X_VERSION_10_10
#define MAC_OS_X_VERSION_10_10      101000
#endif /* MAC_OS_X_VERSION_10_10 */

#if !TARGET_OS_IPHONE
	#define EMB_YOSEMITE_OR_MORE_AT_COMPILE_TIME	(MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_10)
	#define EMB_YOSEMITE_OR_MORE_AT_RUNTIME			(NSClassFromString(@"NSUserActivity") != nil)
#endif /* !TARGET_OS_IPHONE */

/*
	Note:
	
	this was removed from analysis for <https://realmacsoftware.lighthouseapp.com/projects/24268/tickets/1280>
	
	this is fixed in Xcode 4.3 and analysis is turned back on
 */
#define SWITCH_SCOPE_ANALYZE_CRASH_FIXED_EMBER_BUG_1280 ((__clang_major__ > 3) || (__clang_major__ == 3 && __clang_minor__ > 0))
#define ALLOW_SWITCH_SCOPE_ANALYSIS SWITCH_SCOPE_ANALYZE_CRASH_FIXED_EMBER_BUG_1280
