//
// Copyright (C) 2009-2012 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//

#import <Foundation/Foundation.h>
#import <TargetConditionals.h>

@interface NSFileManager (EMBExtensions)

- (NSURL *)temporaryDirectoryAtURL:(NSURL *)url error:(NSError **)errorRef;

- (NSURL *)temporaryDirectoryURLWithError:(NSError **)errorRef;

- (BOOL)emb_trashItemAtURL:(NSURL *)itemURL error:(NSError **)errorRef;

/*!
	\brief
	Checks whether the item at this URL has a local version.
	Returns YES if the item is not ubiquitous and YES if the data is ubiquitous and its downloaded status is
	either NSURLUbiquitousItemDownloadingStatusDownloaded or NSURLUbiquitousItemDownloadingStatusCurrent.
 */
- (BOOL)localVersionExistsForItemAtURL:(NSURL *)itemURL;

/*!
	\brief
	Checks whether the item at this URL is ubiquitous and whether it has already been downloaded if such.
	In case the item has not been downloaded yet, this method will return NO but it will first kick off a download.
 */
- (BOOL)canCoordinateReadingOnItemWithoutBlockingOnUbiquitousDownloadAtURL:(NSURL *)itemURL;

#if !TARGET_OS_IPHONE
- (NSString *)defaultApplicationGroupIdentifier;
- (NSURL *)containerURLForDefaultSecurityApplicationGroup;
#endif

@end
