//
//  EMBEmberLibraryMigrationOperation.h
//  EmberCommon
//
//  Created by Damien DeVille on 8/13/13.
//  Copyright (c) 2013 Realmac Software. All rights reserved.
//

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@interface EMBEmberLibraryMigrationOperation : EMBConcurrentOperation <EMBProgressOperation>

- (id)initWithCurrentLibraryIdentifier:(NSURL *)currentLibraryIdentifier destinationLibraryIdentifier:(NSURL *)destinationLibraryIdentifier;

@property (readonly, copy, atomic) NSNumber * (^completionProvider)(NSError **errorRef);

@end

/*!
	\brief
	The migration is composed of 2 phases:
		- 1: A critical one, the store migration, that cannot be cancelled.
		- 2: The file migration for which we record attempts in phase 1. If the migration is stopped during this phase, it will be restored on next launch.
	This notification is posted once phase 1 has successfully completed so that the host application
	can mark the migration as succeeded.
 */
extern NSString * const EMBEmberLibraryMigrationOperationCriticalMigrationDidCompleteNotification;
