//
//  EMBSnapBatchExportOperation.h
//  EmberCommon
//
//  Created by Damien DeVille on 02/11/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@class NSManagedObjectContext;
@class EMBEmberLibrary;

typedef NS_ENUM(NSUInteger, EMBSnapBatchExportType) {
	EMBSnapBatchExportTypeDocument,
	EMBSnapBatchExportTypeImage,
	EMBSnapBatchExportTypeOriginal,
};

@interface EMBSnapBatchExportOperation : EMBConcurrentOperation <EMBProgressOperation>

- (id)initWithExportType:(EMBSnapBatchExportType)exportType snapObjectIDs:(NSArray *)snapObjectIDs managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary exportLocation:(NSURL *)exportLocation exportFileNames:(NSArray *)exportFileNames exportOptions:(NSDictionary *)exportOptions;

@property (readonly, copy, atomic) NSArray * (^completionProvider)(NSError **errorRef);

@end
