//
//  EMBSnapImageExportOperation.h
//  EmberCommon
//
//  Created by Damien DeVille on 02/10/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@class NSManagedObjectID, NSManagedObjectContext;
@class EMBSnap, EMBEmberLibrary;

@protocol EMBSnapImageExportOperationSnapObjectIDProvider <NSObject>
@property (readonly, atomic) NSManagedObjectID * (^completionProvider)(NSError **);
@end

@protocol EMBSnapImageExportOperationExportLocationProvider <NSObject>
@property (readonly, atomic) NSURL * (^completionProvider)(NSError **);
@end

@protocol EMBSnapImageExportOperationExportFilenameProvider <NSObject>
@property (readonly, atomic) NSString * (^completionProvider)(NSError **);
@end

@protocol EMBSnapImageExportOperationExportOptionsProvider <NSObject>
@property (readonly, atomic) NSDictionary * (^completionProvider)(NSError **);
@end

extern NSString * const EMBSnapImageExportFileTypeOptionKey;
extern NSString * const EMBSnapImageExportAnnotationsOptionKey;
extern NSString * const EMBSnapImageExportTagsOptionKey;
extern NSString * const EMBSnapImageExportSizeOptionKey;
extern NSString * const EMBSnapImageExportScaleOptionKey;

@interface EMBSnapImageExportOperation : EMBConcurrentOperation <EMBProgressOperation>

- (id)initWithSnapObjectID:(NSManagedObjectID *)snapObjectID managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary exportLocation:(NSURL *)exportLocation exportFilename:(NSString *)exportFilename exportOptions:(NSDictionary *)exportOptions;
- (id)initWithSnapObjectIDProvider:(NSOperation <EMBSnapImageExportOperationSnapObjectIDProvider> *)snapObjectIDProvider managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary exportLocationProvider:(NSOperation <EMBSnapImageExportOperationExportLocationProvider> *)exportLocationProvider exportFilenameProvider:(NSOperation <EMBSnapImageExportOperationExportFilenameProvider> *)exportFilenameProvider exportOptionsProvider:(NSOperation <EMBSnapImageExportOperationExportOptionsProvider> *)exportOptionsProvider;

@property (readonly, copy, atomic) NSURL * (^completionProvider)(NSError **errorRef);

@end
