//
//  EMBSubscriptionItemImportOperation.h
//  EmberTouch
//
//  Created by Damien DeVille on 02/12/2011.
//  Copyright (c) 2011 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@class NSManagedObjectID, NSManagedObjectContext;
@class EMBFeedImage;

typedef NS_ENUM(NSInteger, EMBSubscriptionItemImportErrorCode) {
	EMBSubscriptionItemImportDuplicateItemError = -3001,
};

@interface EMBSubscriptionItemImportOperation : EMBConcurrentOperation

- (id)initWithFeedImage:(EMBFeedImage *)imageItem subscriptionObjectID:(NSManagedObjectID *)subscriptionObjectID managedObjectContext:(NSManagedObjectContext *)managedObjectContext;

@property (readonly, copy, atomic) NSManagedObjectID * (^completionProvider)(NSError **errorRef);

@end
