//
//  EMBSubscriptionRefreshOperation.h
//  EmberTouch
//
//  Created by Damien DeVille on 05/12/2011.
//  Copyright (c) 2011 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@class NSManagedObjectID, NSManagedObjectContext;
@class EMBEmberLibrary;

/*!
	\brief
	Operation that takes a subscription and from it:
		- fetch the latest feeds given the subscription feed URL
		- parse the feeds and create RSS image objects from each of them
		- determine whether a subscription item has already been created for each of them
		- create a new subscription item in the context for each new one
 */
@interface EMBSubscriptionRefreshOperation : EMBConcurrentOperation <EMBProgressOperation>

- (id)initWithSubscriptionID:(NSManagedObjectID *)subscriptionID managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

@property (readonly, copy, atomic) NSArray * (^completionProvider)(NSError **errorRef);

@end
