//
// Copyright (C) 2008-2012 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//

#import <Foundation/Foundation.h>

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

typedef NS_ENUM(NSUInteger, EMBThumbnailSizeType) {
	EMBThumbnailSizeThumbnail,
	EMBThumbnailSizePreview,
	EMBThumbnailSizeScrobbler,
};

@class EMBEmberLibrary;

@protocol EMBThumbnailGenerationURLCompletionProvider <NSObject>

@property (readonly, atomic) NSURL * (^completionProvider)(NSError **);

@end

@interface EMBThumbnailGenerationOperation : EMBConcurrentOperation

- (id)initWithSizeType:(EMBThumbnailSizeType)sizeType thumbnailDestinationURL:(NSURL *)thumbnailDestinationURL snapMediaURL:(NSURL *)snapMediaURL emberLibrary:(EMBEmberLibrary *)emberLibrary;
- (id)initWithSizeType:(EMBThumbnailSizeType)sizeType thumbnailDestinationURL:(NSURL *)thumbnailDestinationURL snapMediaURLProvider:(NSOperation <EMBThumbnailGenerationURLCompletionProvider> *)snapMediaURLProvider emberLibrary:(EMBEmberLibrary *)emberLibrary;
- (id)initWithSizeType:(EMBThumbnailSizeType)sizeType thumbnailDestinationURLProvider:(NSOperation <EMBThumbnailGenerationURLCompletionProvider> *)thumbnailDestinationURLProvider snapMediaURLProvider:(NSOperation <EMBThumbnailGenerationURLCompletionProvider> *)snapMediaURLProvider emberLibrary:(EMBEmberLibrary *)emberLibrary;

@property (readonly, copy, atomic) NSURL * (^completionProvider)(NSError **errorRef);

@end
