//
//  EMBWebSnapOperation.h
//  EmberCommon
//
//  Created by Damien DeVille on 01/10/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <TargetConditionals.h>

#if !TARGET_OS_IPHONE

#import <Cocoa/Cocoa.h>

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@class EMBEmberLibrary;

@interface EMBWebSnapOperation : EMBConcurrentOperation <EMBProgressOperation>

- (id)initWithURL:(NSURL *)pageURL bookmarkOnly:(BOOL)bookmarkOnly pageWidth:(CGFloat)pageWidth pageCookies:(NSString *)pageCookies managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

@property (readonly, copy, atomic) NSManagedObjectID * (^completionProvider)(NSError **errorRef);

@end

@interface EMBWebSnapOperation (/* Import customization */)

@property (strong, nonatomic) NSDictionary *snapMetadata;

@end

#endif /* !TARGET_OS_IPHONE */
