//
//  RMSharedUserDefaults.h
//  RMSharedPreferences
//
//  Created by Damien DeVille on 26/11/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface RMSharedUserDefaults : NSUserDefaults

+ (RMSharedUserDefaults *)standardUserDefaults;

/*!
	\brief
	Designated initializer.
	
	\params
	applicationGroupIdentifier: the identifier for the application group the user defaults should target.
	You can pass nil to retrieve the default group container identifier. Throws an exception if no default identifier can be retrieved.
 */
- (id)initWithApplicationGroupIdentifier:(NSString *)applicationGroupIdentifier;

@end

extern NSString * const RMSharedUserDefaultsDidChangeDefaultNameKey;
extern NSString * const RMSharedUserDefaultsDidChangeDefaulValueKey;
